package jp.co.sds_corp.morphogenesis.sample;

import jp.co.sds_corp.morphogenesis.PointMap;
import jp.co.sds_corp.morphogenesis.Rule;
import jp.co.sds_corp.util.config.IConfigurable;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class Rule1 implements Rule, IConfigurable
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	int max = 4;

	@Override
	public void init(IConfiguration config) throws Exception {
		String var = config.getAttributes().get("max");
		if (var != null && var.length() > 0) {
			this.max = Integer.valueOf(var);
		}
	}

	@Override
	public void check(PointMap pointMap, int x, int y) {
		int color = pointMap.get(x, y);

		int mark = 0;
		for (int j = -1; j <= 1; j++) {
			int sx = 0;
			int endx = 0;
			switch (j) {
			case -1:
			case 1:
				if ((y % 2) == 0) {
					sx = -1;
				}
				endx = sx + 1;
				break;
			case 0:
				sx = -1;
				endx = 1;
				break;
			}
			for (int i = sx; i <= endx; i++ ) {
				if (i == 0 && j == 0) {
					continue;
				}
				int target;
				try {
					target = pointMap.get(x + i, y + j);
				} catch (ArrayIndexOutOfBoundsException ex) {
					continue;
				}
/*
				if (y == 2) {
					logger.trace("(" + (x+i) + "," + (y+j) + ") " + target);
				}
*/
				if (target != color) {
					mark++;
				}
			}
		}
/*
		if (y == 2) {
			logger.trace("(" + x + "," + y + ")=" + mark);
		}
*/
		if (mark >= max) {
			pointMap.mark(x, y);
		}
	}

}
