package jp.co.sds_corp.morphogenesis.sample;

import jp.co.sds_corp.morphogenesis.PointMap;
import jp.co.sds_corp.morphogenesis.Rule;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class Rule2 implements Rule
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	int max = 0;

	@Override
	public void check(PointMap pointMap, int x, int y) {
		StringBuilder buf = new StringBuilder();
		int color = pointMap.get(x, y);

		int mark = 0;
		for (int j = -2; j <= 2; j++) {
			int sx = 0;
			int endx = 0;
			switch (j) {
			case -2:
			case 2:
				sx = -1;
				endx = 1;
				break;
			case -1:
			case 1:
				sx = -1;
				if ((y % 2) == 0) {
					sx = -2;
				}
				endx = sx + 3;
				break;
			case 0:
				sx = -2;
				endx = 2;
				break;
			}
			for (int i = sx; i <= endx; i++ ) {
				if (i == 0 && j == 0) {
					continue;
				}
				int target;
				try {
					target = pointMap.get(x + i, y + j);
				} catch (ArrayIndexOutOfBoundsException ex) {
					continue;
				}
				buf.append("(" + (x+i) + "," + (y+j) + ")=" + target + "\n");
				if (target != color) {
					mark++;
				}
			}
		}
		if (mark <= max) {
//			logger.trace("(" + x + "," + y + ") " + buf.toString());
			pointMap.mark(x, y);
		}
	}

}
